*-------------------------------------------------------
* snow.prg    J.Peschar  24/1/92
* variable s
*-------------------------------------------------------

#include "snow.ch"

proc snow

local getlist := {}

local s_col    := array(20)
local s_row    := array(20)
local s_f_col  := array(20)
local s_colour := array(13)

local s_wanthse , s_len    , s_house  , s_loop    , s_new     , s_count
local s_char_f  , s_char_r , s_cycles , s_char_il , s_char_ir , s_left
local s_start   , s_type   , s_flakes , s_loop2   , s_max     , s_items
local s_clr     , s_levels , s_cont   , s_char_l  , s_cha     , s_loop3
local s_house2  , s_colour_s

set stat  off
set score off
set talk  off
set date  brit

clear
setmode(50)
blinkbit(.f.)
srand(val(right(time(),2)) * seconds())     // seed the random number gen

@ 00,00 to maxrow(),maxcol() double
cen(04,'SNOW FLAKES')
@ 07,05 say 'A totally pointless program that was inspired by a screen saver on a'
@ 08,05 say 'Macintosh in my office. After thinking about the logic behind the'
@ 09,05 say 'program I decided to try and reproduce the program in Clipper. The'
@ 10,05 say 'result is a program that does basically nothing except simulate a '
@ 11,05 say 'bunch of falling snow flakes.'
* 12
@ 13,05 say 'Snow flakes fall until they hit something. If a flake hits either the'
@ 14,05 say 'ground or a baricade then it will stop falling (obviously). If a flake'
@ 15,05 say 'hits a conveyor belt then the flake will travel along the conveyor'
@ 16,05 say 'until it either hits something or falls off the edge.'
* 17
@ 18,05 say 'The only function of the original Mac Screen saver that I have been'
@ 19,05 say 'unable to simulate is the way the flakes randomly build up on a slope'
@ 20,05 say 'and when the accumulation of flakes reaches a critical stage they start'
@ 21,05 say 'again. This gives a more random and interesting look to the mounds of'
@ 22,05 say 'flakes that buildup on the ground and barricades.'
* 23
@ 24,05 say 'Start the program by entering the number of flakes you would like. The'
@ 25,05 say 'smaller the number the faster the program operates. You can terminate'
@ 26,05 say 'the program at any time by pressing "ESC".'

setcolor('gr+/n*')
cen(33,'                                        ')
cen(34,' Written by John Peschar, January 1992  ')
cen(35,'                                        ')
cen(36,'           In Clipper 5.01              ')
cen(37,'                                        ')

setcolor('w/n')
cen(40,'If you would have any comments you can send them to')
cen(42,'JOHN PESCHAR')
cen(43,'PO BOX 145  ')
cen(44,'THE JUNCTION')
cen(45,'NSW 2291    ')
cen(46,'AUSTRALIA   ')

s_flakes = 5
cen(30,'How many Snow Flakes (1-20)   ')
@ 30,col()-2 get s_flakes pict '99' range 1,20
read

s_wanthse = 1
@ 30,01 say space(77)
cen(30,'How many Houses (0-2)  ')
@ 30,col()-1 get s_wanthse pict '9' range 0,2
read

s_colour_s = 1
@ 30,01 say space(77)
cen(30,'Which Colour Scheme (1-3)  ')
@ 30,col()-1 get s_colour_s pict '9' range 1,3
read

do case
   case s_colour_s = 1
      s_colour[ 1] = 'w+/b*'
      s_colour[ 2] = 'w+/b*'
      s_colour[ 3] = 'w+/b*'
      s_colour[ 4] = 'w+/b*'
      s_colour[ 5] = 'w+/b*'
      s_colour[ 6] = 'w+/b*'
      s_colour[ 7] = 'w+/b*'
      s_colour[ 8] = 'w+/b*'
      s_colour[ 9] = 'w+/b*'
      s_colour[10] = 'w+/b*'
      s_colour[11] = 'w+/b*'
      s_colour[12] = 'w+/b*'
      s_colour[13] = 'w+/b*'
   case s_colour_s = 2
      s_colour[ 1] = 'w+ /b*'
      s_colour[ 2] = 'r+ /b*'
      s_colour[ 3] = 'g+ /b*'
      s_colour[ 4] = 'w+ /b*'
      s_colour[ 5] = 'gr+/b*'
      s_colour[ 6] = 'bg+/b*'
      s_colour[ 7] = 'rb+/b*'
      s_colour[ 8] = 'w  /b*'
      s_colour[ 9] = 'r  /b*'
      s_colour[10] = 'g  /b*'
      s_colour[11] = 'gr /b*'
      s_colour[12] = 'bg /b*'
      s_colour[13] = 'rb /b*'
   case s_colour_s = 3
      s_colour[ 1] = 'w+ /n'
      s_colour[ 2] = 'r+ /n'
      s_colour[ 3] = 'g+ /n'
      s_colour[ 4] = 'w+ /n'
      s_colour[ 5] = 'gr+/n'
      s_colour[ 6] = 'bg+/n'
      s_colour[ 7] = 'rb+/n'
      s_colour[ 8] = 'w  /n'
      s_colour[ 9] = 'r  /n'
      s_colour[10] = 'g  /n'
      s_colour[11] = 'gr /n'
      s_colour[12] = 'bg /n'
      s_colour[13] = 'rb /n'
endcase

set cursor off

do while .t.

   * draw the sky
   setcolor('n/b*')
   @ 00,00,maxrow(),maxcol() box '         '

   * draw the grass
   setcolor('g/g*')
   @ maxrow()-1,00 say repl(s_grass,maxcol()+1)
   @ maxrow()  ,00 say repl(s_grass,maxcol()+1)

   * draw a house if required
   if s_wanthse != 0
      setcolor('w+/b')
      s_house = RAND(55) + 5  && random position for house

      @ maxrow()-16,s_house + 8 say         ''
      @ maxrow()-15,s_house + 7 say        '  '
      @ maxrow()-14,s_house + 6 say       '    '
      @ maxrow()-13,s_house + 5 say      '      '
      @ maxrow()-12,s_house + 4 say     '        ==='
      @ maxrow()-11,s_house + 3 say    '          =='
      @ maxrow()-10,s_house + 2 say   '            ='
      @ maxrow()-09,s_house + 1 say  '              '
      @ maxrow()-08,s_house     say 'Ŀ'
      @ maxrow()-07,s_house + 1 say  '       Ŀ'
      @ maxrow()-06,s_house + 1 say  ' Ŀ      '
      @ maxrow()-05,s_house + 1 say  ' Ĵ      '
      @ maxrow()-04,s_house + 1 say  '      o'
      @ maxrow()-03,s_house + 1 say  '            '
      @ maxrow()-02,s_house + 1 say  '            '
      @ maxrow()-14,s_house + 14 say '==='
      @ maxrow()-13,s_house + 14 say '==='
      if s_wanthse = 2
         do while .t.
            s_house2 = RAND(55) + 5
            if s_house2 > s_house + 20 .or. s_house2 < s_house - 20
               exit
            endif
         enddo
         @ maxrow()-16,s_house2 + 8 say         ''
         @ maxrow()-15,s_house2 + 7 say        '  '
         @ maxrow()-14,s_house2 + 6 say       '    '
         @ maxrow()-13,s_house2 + 5 say      '      '
         @ maxrow()-12,s_house2 + 4 say     '        ==='
         @ maxrow()-11,s_house2 + 3 say    '          =='
         @ maxrow()-10,s_house2 + 2 say   '            ='
         @ maxrow()-09,s_house2 + 1 say  '              '
         @ maxrow()-08,s_house2     say 'Ŀ'
         @ maxrow()-07,s_house2 + 1 say  '       Ŀ'
         @ maxrow()-06,s_house2 + 1 say  ' Ŀ      '
         @ maxrow()-05,s_house2 + 1 say  ' Ĵ      '
         @ maxrow()-04,s_house2 + 1 say  '      o'
         @ maxrow()-03,s_house2 + 1 say  '            '
         @ maxrow()-02,s_house2 + 1 say  '            '
         @ maxrow()-14,s_house2 + 14 say '==='
         @ maxrow()-13,s_house2 + 14 say '==='
      endif
   endif

   * now draw levels
   s_start  = RAND(3) + 6               && start at row 6,7 or 8
   s_levels = 5 + iif(s_wanthse != 0,2,0) && number of levels

   for s_loop = 1 to s_levels
      s_items = RAND(3) + 1             && random number of items per level
      s_max   = maxcol() / s_items      && maximum width of any item on this level
      s_left  = RAND(3) + 2             && random horiz starting position
      for s_loop2 = 1 to s_items
         s_type = RAND(100)             && random item type
         s_len  = RAND(s_max) + 5       && random length for this item
         if s_left + s_len > 77
            s_len = s_len - ((s_left + s_len) - 77)
         endif

         do case
            case s_type > 85
               setcolor('gr+/b')
               @ s_start,s_left say repl(s_baricade ,s_len)

            case s_type > 50
               setcolor('g+/b')
               @ s_start,s_left say repl(s_right_con,s_len)

            case s_type > 15
               setcolor('r+/b')
               @ s_start,s_left say repl(s_left_con ,s_len)
         endcase
         s_left = s_left + s_len + 4 + RAND(4)
         if s_left > 75
            exit
         endif
      next
      s_start = s_start + 5 + RAND(2)
      if s_start > iif(s_wanthse != 0,maxrow() - 18,maxrow() - 5)
         exit
      endif
   next

   clear typeahead                          && clear the keyboard buffer
   s_clr  = setcolor("r/gr*")               && get old color and set new one
   s_cont = 'N'
   s_cha  = savescreen(02,24,06,55)         && save the screen to a variable
   @ 02,24 clear to 06,55
   @ 02,24 to 06,55 double
   cen(04,'Play with these levels ')
   @ 04,col() get s_cont pict 'Y'
   read
   restscreen(02,24,06,55,s_cha)           && restore screen
   setcolor(s_clr)                         && restore color

   if s_cont = 'Y'
      exit
   endif
enddo

setcolor('w+/b*')

for s_loop = 1 to s_flakes
   do while .t.
      s_row[s_loop]   = RAND(03) - 1
      s_col[s_loop]   = RAND(77) + 1          && makes the range 1-78
      s_f_col[s_loop] = s_colour[RAND(13)]    && random flake colour
      if readscreen(s_row[s_loop],s_col[s_loop],1) = s_sky
         exit
      endif
   enddo
   @ s_row[s_loop],s_col[s_loop] say s_f_snow color s_f_col[s_loop]
next

s_loop   = 0
s_count  = 0
s_cycles = 0

do while esckey()

   @ maxrow(),20 say ' Flakes ' + str(s_count ,5) + ' ' color 'n/g*'
   @ maxrow(),35 say ' Cycles ' + str(s_cycles,5) + ' ' color 'n/g*'

   s_cycles  = s_cycles + iif(s_loop = s_flakes,1,0)
   s_loop    = iif(s_loop = s_flakes,1,s_loop + 1)
   s_new     = .f.                        && if true then generate new flate
   s_char_f  = readscreen(s_row[s_loop] + 1,s_col[s_loop]    ,1)  && one char forward
   s_char_l  = readscreen(s_row[s_loop] + 1,s_col[s_loop] - 1,1)  && one char forward & left
   s_char_r  = readscreen(s_row[s_loop] + 1,s_col[s_loop] + 1,1)  && one char forward & right
   s_char_il = readscreen(s_row[s_loop]    ,s_col[s_loop] - 1,1)  && one char left
   s_char_ir = readscreen(s_row[s_loop]    ,s_col[s_loop] + 1,1)  && one char right

   do case
      case s_char_f = s_sky                       && nothing forward so keep falling
         @ s_row[s_loop],s_col[s_loop] say s_sky  && wipe out old snow flake
         s_row[s_loop]++                          && calculate new position
         @ s_row[s_loop],s_col[s_loop] say s_f_snow color s_f_col[s_loop]

      case s_char_f = s_grass .or. ;              && we hit the ground
           s_char_f = s_baricade                  &&   or a baricade
         s_new = .t.                              && new flake needs to be generated

      case s_char_f = s_left_con                      && we hit a left conveyor
         if s_char_il = s_sky .or. ;
            s_char_il = s_f_snow
            @ s_row[s_loop],s_col[s_loop] say s_sky   && clear old snow flake
            s_col[s_loop]--                           && if left conveyor then move left
            @ s_row[s_loop],s_col[s_loop] say s_f_snow color s_f_col[s_loop]
         else
            s_new = .t.                               && new flake needs to be generated
         endif

      case s_char_f = s_right_con                     && we hit a right conveyor
         if s_char_ir = s_sky .or. ;
            s_char_ir = s_f_snow
            @ s_row[s_loop],s_col[s_loop] say s_sky   && clear old snow flake
            s_col[s_loop]++                           && if right conveyor then move right
            @ s_row[s_loop],s_col[s_loop] say s_f_snow color s_f_col[s_loop]
         else
            s_new = .t.                        && new flake needs to be generated
         endif

      case s_char_f = s_l_snow                 && weve hit a fallen flake
         if s_char_l != s_sky .and. ;          && if left and
            s_char_r != s_sky                  &&   right blocked then a new
            s_new = .t.                        &&     flake needs to be generated
         else
            if s_col[s_loop] != 0 .and. ;        // were in not column 0
               s_col[s_loop] != maxcol()         //    or at rightmost column
               @ s_row[s_loop],s_col[s_loop] say s_sky  && clear old snow flake
               s_row[s_loop]++                          && set new vertical line
               if RAND(2) = 1
                  if s_char_l = s_sky
                     s_col[s_loop]--
                  else
                     s_col[s_loop]++
                  endif
               else
                  if s_char_r = s_sky
                     s_col[s_loop]++
                  else
                     s_col[s_loop]--
                  endif
               endif
               @ s_row[s_loop],s_col[s_loop] say s_f_snow color s_f_col[s_loop]
            else
               s_new = .t.
            endif
         endif

      case s_char_f = s_f_snow                 && another falling flake in front
         * do nothing, no movement
   endcase

   * if a new flake is needed or screen boundaries have been exceeded
   if s_col[s_loop] < 0 .or. s_col[s_loop] > maxcol() .or. s_new
      @ s_row[s_loop],s_col[s_loop] say s_l_snow color s_f_col[s_loop] // we've landed
      for s_loop3 = 1 to 255
         s_row[s_loop] = RAND(03) - 1             // random vertical start
         s_col[s_loop] = RAND(77) + 1             // range 1 to 78
         s_f_col[s_loop] = s_colour[RAND(13)]     // random flake colour
         if readscreen(s_row[s_loop],s_col[s_loop],1) != s_f_snow .and. ;
            readscreen(s_row[s_loop],s_col[s_loop],1) != s_l_snow
            exit
         endif
      next
      if s_loop3 > 250
         setcolor('gr+/r')
         @ 08,30 clear to 12,50
         @ 08,30 to 12,50 double
         cen(10,'Finished. ')
         waitkey(18*0)
         exit
      endif
      s_count++
      @ s_row[s_loop],s_col[s_loop] say s_f_snow color s_f_col[s_loop]
   endif
enddo

setcolor('w/n')
clear screen
@ 00,00 to maxrow(),maxcol() double
cen(04,'SNOW FLAKES')
cen(07,'Thank you for playing SNOW FLAKES')
@ 09,05 say 'If you make improvements or can think of ways to speed up this program'
@ 11,05 say 'then send your modified source code or suggested changes to the'
@ 13,05 say 'following address and I will re-issue this program under a new'
@ 15,05 say 'version number with the appropriate credit given. The more changes'
@ 17,05 say 'or alterations we make the more interesting and challenging this'
@ 19,05 say 'program will become.'
cen(22,'CAN YOU THINK OF ANY IMPROVEMENTS ?')
cen(38,'JOHN PESCHAR')
cen(39,'PO BOX 145  ')
cen(40,'THE JUNCTION')
cen(41,'NSW 2291    ')
cen(42,'AUSTRALIA   ')
cen(maxrow()-2,'Press a key')
set cursor off

waitkey(18*60)

setcolor('w/n')

clear screen
@ 00,00 to maxrow(),maxcol() double
cen(04,'SNOW FLAKES')
cen(06,'Contributors Screen')
@ 10,05 say 'Version 1.00     Original Version issued May 22 1992 by'
@ 11,05 say '                            John Peschar'

cen(maxrow()-2,'Press a key')

waitkey(18*60)

setmode(3)
set cursor on
clear
quit

*!*********************************************************************
*!
*!       func: CEN()
*!
*!*********************************************************************
func cen(x_row , x_mess , x_clr)
   if pcount() = 3
      @ x_row,00
   endif
   @ x_row,40 - (len(x_mess) / 2) say x_mess
return ""

*!*********************************************************************
*!
*!       func: ESCKEY()
*!
*!*********************************************************************
func esckey
   local x_cont , x_clr , x_cha
   local getlist := {}
   waitkey()                                   && scan the keyboard
   x_cont = 'N'
   if lastkey() = 27
      clear typeahead                          && clear the keyboard buffer
      x_clr  = setcolor("w+/rb")               && get old color and set new one
      x_cont = 'N'
      x_cha  = savescreen(08,24,12,55)         && save the screen to a variable
      @ 08,24 clear to 12,55
      @ 08,24 to 12,55 double
      cen(10,'Do you really want to quit ')
      @ 10,col() get x_cont pict 'Y'
      read
      restscreen(08,24,12,55,x_cha )           && restore screen
      setcolor(x_clr)                          && restore color
   endif
return(x_cont='N')

* eof : snow.prg
*----------------

